.lm 8.rm 72.nhy

.no autosubtitle .style headers 3,0,0
.pg.uc.ps 58,80.lm 8.rm 72
.hd
.hd mixed
.head mixed

.st ########netlnk##network link functions for Decus C
.pg
.hl 1 ^&network link functions for Decus C\&
.s 2
.c ;**********
.c ;* netlnk *
.c ;**********
.s 2
.lm +8
.s.i -8;NAME:	netlnk -- network link functions for Decus C
.s.f
.i -8;SYNOPSIS:
.s.nf
.nf
  ___#include <stdnet.h>
.fill
.s
.nf
  NIOV *opn__net(nfp)
  int (*nfp)();
.fill
.s
.nf
  clsnet()
.fill
.s
.nf
  NIOV *con__net(dest__node, dest__task)
  char *dest__node, *dest__task;
.fill
.s
.nf
  NIOV *con__obj(dest__node, dest__obj)
  char *dest__node;
  int dest__obj;
.fill
.s
.nf
  NIOV *acc__net(con__buf__ptr)
  struct a__conblk *con__buf__ptr;
.fill
.s
.nf
  dsc__net(np, msg)
  NIOV *np;
  char *msg;
.fill
.s.f
.i -8;DESCRIPTION:
.s
This group of functions allows openning a Decnet network,
reading network data, and establishing and maintaining
links.
.s
Opn__net() connects a task to the network. It must be issued
before any other network calls. See the DECnet documentation
on OPN$.
.s
Opn__net() takes one argument, the address of a function
to handle network messages. If the argument is NULL, network
messages will still be dequeued from the netword data queue,
but will be discarded.
.s
If specified, the network message function will be called
as follows:
.s.nf
.nf
	netmsg(iosb, msg)
	int iosb[2];	/* stat block from GND$ call */
	char *msg;	/* message from GND$ */
.s
.fill
.s.f
You should be familiar with how GND$ returns data before
using this function. The msg pointer points to a buffer
large enough to accept a full connect request message
and can be passed directly to the acc__net() function.
.s
Your netmsg() function is called at ast state, and the
buffer pointed to by msg is allocated dynamically. It
is freed when your function returns. If you need to save
any data from the message buffer, copy it to your own
buffer before returning.
.s
Cls__net() closes the network data queue and returns the
NIOV data structure and lun allocated for the link.
Closing the network link while any data links are still
up will cause unpredictable problems.
.s
Con__net() will attempt to connect the the remote node and
task specified in the arguments. If it succeeds, it returns
an NIOV pointer. If the connect fails, NULL is returned and
the error condition is returned in $$nerr. You should declare
$$nerr as:
.s.nf
.nf
	extern int $$nerr;
.fill
.s.f
if you wish to use it. The pointer returned by con__net()
is required for network IO functions such as put__net() and
get__net().
.s
Con__obj() is similar to con__net(), but is used to connect
to remote number network objects.
.s
Acc__net() will attempt to accept a connect request from
another node. It is normally called with a connect buffer
retrieved from the task's network data queue.
.s
Acc__net() returns an NIOV pointer if successful, and NULL
on error. The error condition is availible from $$nerr.
.s
Dsc__net() disconnects a logical link. The NIOV pointer
must point to an open logical link, if not, unpredicatable
errors will result.
.s
You may pass a message to the other
end of the link when disconnecting by passing a pointer to
the message in msg. Set the msg argument to 0 if no message
is needed.
.s
Dsc__net() frees the NIOV structure and lun used for the
link. The memory area pointed to by np is returned to free
memory, don't try to reuse np.
.s
.i -8;IMPLEMENTATION DETAILS:
.s
These routines try to mimic the Decus C interface to the
file system. NIOV is described in stdio.h.
.s
NIOV data structures are allocated with malloc and freed
as necessary.
.s
Be sure you understand how the user supplied network
message function is called. The current implimentation
is an attempt to provide the greatest flexibility while
still hiding as much of the gory network detail as possible.
.s
The internal function getmsg() will check for the NT.DSC,
NT.ABT, and NT.ABO and free the appropriate NIOV structures
and luns AFTER calling the user supplied message function.
.s
.i -8;BUGS:
.s
The routines try to do some error checking, but if a bad
NIOV pointer is passed to a function, many strange things
could happen, not the least of which is clobbering random
areas of memory. Be careful.
.s
.i -8;EDIT HISTORY:
.s
.nf
  01 05/08/85 hjj fixed bad check for NDA in gndw.
.lm 8.rm 72.nhy

